# THIS CONTROLS ALL M11'S BOSS ON MAIN PHASE 3

scoreboard players add timer boss 1

# applies mycelium particle effect for different phases
execute if score phase boss matches 1..3 run function lily:m11/boss_p3_phase1_particles
execute if score phase boss matches 4..5 run function lily:m11/boss_p3_phase4_particles

# apply resistance for all difficulties
execute if score Difficulty Difficulty matches 1..3 as @e[type=wither_skeleton,tag=boss] at @s run effect give @s resistance infinite 3 true

# PHASE 1 ABILITIES (wither phase) - WITHERING GAS, CHARRED ARMY, FIREBALL HELL, WITHER GAS WALL
execute if score timer boss matches 100 if score phase boss matches 1 run function lily:m11/boss_p3_withering_gas
execute if score timer boss matches 260 if score phase boss matches 1 as @e[type=wither,tag=boss] at @s run function lily:m11/boss_p3_charred_army
execute if score timer boss matches 400 if score phase boss matches 1 run function lily:m11/boss_p3_fireball_hell_prepare
execute if score timer boss matches 560 if score phase boss matches 1 run function lily:m11/boss_p3_wither_gas_wall_prepare
execute if score timer boss matches 620 if score phase boss matches 1 run scoreboard players set timer boss 0

# PHASE 2 ABILITIES (wither skeleton phase) GROUND POUND, INSTA TP, VOID CRYSTAL SHIELDERS, BOW SWITCH
execute if score timer boss matches 0 if score phase boss matches 2 as @e[type=wither_skeleton,tag=boss] at @s run function lily:m11/boss_p3_melee_switch
execute if score timer boss matches 100 if score phase boss matches 2 as @e[type=wither_skeleton,tag=boss] at @s run function lily:m11/boss_p3_ground_pound_jump
execute if score timer boss matches 200 if score phase boss matches 2 as @e[type=wither_skeleton,tag=boss] at @s run function lily:m11/boss_p3_insta_tp
execute if score timer boss matches 260 if score phase boss matches 2 as @e[type=wither_skeleton,tag=boss] at @s run function lily:m11/boss_p3_void_crystal_shielders_activate
execute if score timer boss matches 360 if score phase boss matches 2 as @e[type=wither_skeleton,tag=boss] at @s run function lily:m11/boss_p3_bow_switch
execute if score timer boss matches 520 if score phase boss matches 2 run scoreboard players set timer boss 0

# PHASE 3 ABILITIES (shapeshifer phase - he starts morphing into your allies)
# CORRUPTED JERRY - FIREBALLS, ANTIMATTER DECOMP
# SHADOW NETHERITIS - FIRE TRAIL, FALLING BLOCKS
# SHADOW ZOPIG - STUN SPELL, FIRE MAGIC
# SHADOW NAUTICA - ARENA TURNS INTO WATER, BUBBLE SHOTGUN, MINING FATIGUE 4

execute if score phase boss matches 3 as @e[tag=shapeshifted] run effect give @s resistance infinite 3 true

execute if score timer boss matches 0 if score phase boss matches 3 run function lily:m11/boss_p3_shapeshift_rng_pick

execute if score timer boss matches 1..200 if score phase boss matches 3 if score shapeshift_chosen boss matches 1 run function lily:m11/boss_p3_jerry_timer
execute if score timer boss matches 1..200 if score phase boss matches 3 if score shapeshift_chosen boss matches 2 run function lily:m11/boss_p3_nether_timer
execute if score timer boss matches 1..200 if score phase boss matches 3 if score shapeshift_chosen boss matches 3 run function lily:m11/boss_p3_zopig_timer
execute if score timer boss matches 1..200 if score phase boss matches 3 if score shapeshift_chosen boss matches 4 run function lily:m11/boss_p3_nautica_timer

execute if score timer boss matches 201 if score phase boss matches 3 run function lily:m11/boss_p3_shapeshift_reset

# PHASE 4 ABILITIES (enraged phase - you now have a constant wither effect and its a bigger arena now - also hes on bow permanently for this phase)
# FIREBALL SPEEN, MACH5TP, MAGIC BOW SHOT, HELL JOCKEY RIDERS
execute if score timer boss matches 100 if score phase boss matches 4 as @e[type=wither_skeleton,tag=boss] at @s run function lily:m11/boss_p3_fireball_speen_activate
execute if score timer boss matches 300 if score phase boss matches 4 run function lily:m11/boss_p3_mach5_tp_activate
execute if score timer boss matches 500 if score phase boss matches 4 as @e[type=wither_skeleton,tag=boss] at @s run function lily:m11/boss_p3_magic_bow_shot
execute if score timer boss matches 700 if score phase boss matches 4 as @e[type=wither_skeleton,tag=boss] at @s run function lily:m11/boss_p3_hell_jockey_riders
execute if score timer boss matches 860 if score phase boss matches 4 run scoreboard players set timer boss 0

# PHASE 5 ABILITIES (the final phase - he gets super buffed at this point/passive bow switch)
# MIMICS, INVISIBILITY, LASER TURRETS
execute if score phase boss matches 5 as @e[type=wither_skeleton,tag=boss] at @s run function lily:m11/boss_p3_passive_switch
execute if score timer boss matches 100 if score phase boss matches 5 as @e[type=wither_skeleton,tag=boss] at @s run function lily:m11/boss_p3_mimics
execute if score timer boss matches 180 if score phase boss matches 5 as @e[type=wither_skeleton,tag=boss] at @s run function lily:m11/boss_p3_invis
execute if score timer boss matches 360 if score phase boss matches 5 if score laser_on boss matches 0 run function lily:m11/boss_p3_laser_turret
execute if score timer boss matches 500 if score phase boss matches 5 run scoreboard players set timer boss 0

# check health for bossbar
execute if score phase boss matches 2 store result bossbar boss value as @e[type=wither_skeleton,tag=boss,limit=1] run data get entity @s Health
execute if score phase boss matches 4..5 store result bossbar boss value as @e[type=wither_skeleton,tag=boss,limit=1] run data get entity @s Health

# stores health for phase changes
execute store result score health boss as @e[type=wither,tag=boss,limit=1] run data get entity @s Health
execute if score phase boss matches 2 store result score health boss as @e[type=wither_skeleton,tag=boss,limit=1] run data get entity @s Health
execute if score phase boss matches 4..5 store result score health boss as @e[type=wither_skeleton,tag=boss,limit=1] run data get entity @s Health

# makes all shapeshifted mobs feed all health into bossbar
execute if score phase boss matches 3 run function lily:m11/boss_p3_shapeshift_bossbar

# makes sounds when hes hit
execute if score phase boss matches 2..5 as @e[type=wither_skeleton,tag=boss] run execute store result score @s boss run data get entity @s HurtTime
execute if score phase boss matches 2..5 as @e[type=wither_skeleton,tag=boss,scores={boss=10}] at @s run playsound minecraft:entity.wither.hurt master @a ~ ~ ~ 1000000 1

# HEALTH PHASE CHECKERS - WHEN WITHER DIES PHASE CHANGES
# PHASE 1 -> PHASE 2
execute unless entity @e[type=wither,tag=boss] if score phase boss matches 1 run setblock 2862 8 -452 minecraft:redstone_block replace

# PHASE 2 -> PHASE 3 - WHEN HES LOW ON HEALTH HE WILL BE TELEPORTED AWAY (and killed) AND THEN SHAPESHIFTING COMES IN
execute if score phase boss matches 2 if score health boss matches ..100 run setblock 2862 8 -448 minecraft:redstone_block replace

# PHASE 3 -> PHASE 4 - ONCE ALL SHAPESHIFT FORMS ARE DEAD
execute if score phase boss matches 3 unless entity @e[tag=shapeshifted] run setblock 2862 8 -444 minecraft:redstone_block replace

# PHASE 4 -> PHASE 5 - ONCE HE HITS HALF HEALTH HE GOES INTO HIS FINAL FORM
execute if score Difficulty Difficulty matches 1 if score phase boss matches 4 if score health boss matches ..240 run function lily:m11/boss_p3_phase5_entry
execute if score Difficulty Difficulty matches 2 if score phase boss matches 4 if score health boss matches ..290 run function lily:m11/boss_p3_phase5_entry
execute if score Difficulty Difficulty matches 3 if score phase boss matches 4 if score health boss matches ..340 run function lily:m11/boss_p3_phase5_entry

# WHEN HES G O N E
execute unless entity @e[type=wither_skeleton,tag=boss] if score phase boss matches 5 run function lily:m11/cs8_start

# THE KILL PIT.
kill @e[x=2872,y=7,z=-439,type=!player,distance=..2]
execute as @e[type=magma_cube] at @s if entity @s[nbt={Size:1}] run tp @s 2872 7 -439

# clears nether star dropped from phase 1
clear @a nether_star